Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.Designer.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.Designer.cs	(revision 2859)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.Designer.cs	(revision 2860)
@@ -24,29 +24,24 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       this.listView = new System.Windows.Forms.ListView();
       this.nameHeader = new System.Windows.Forms.ColumnHeader();
       this.localVersion = new System.Windows.Forms.ColumnHeader();
-      this.uploadButton = new System.Windows.Forms.Button();
-      this.splitContainer = new System.Windows.Forms.SplitContainer();
-      this.label1 = new System.Windows.Forms.Label();
+      this.serverVersion = new System.Windows.Forms.ColumnHeader();
+      this.imageList = new System.Windows.Forms.ImageList(this.components);
+      this.serverUrlLabel = new System.Windows.Forms.Label();
       this.serverUrlTextBox = new System.Windows.Forms.TextBox();
       this.connectButton = new System.Windows.Forms.Button();
-      this.tableLayoutPanel = new System.Windows.Forms.TableLayoutPanel();
-      this.serverPluginDetailsGroupBox = new System.Windows.Forms.GroupBox();
-      this.localPluginDetailsGroupBox = new System.Windows.Forms.GroupBox();
-      this.localPluginDetailsPanel = new System.Windows.Forms.Panel();
-      this.serverVersion = new System.Windows.Forms.ColumnHeader();
-      this.splitContainer.Panel1.SuspendLayout();
-      this.splitContainer.Panel2.SuspendLayout();
-      this.splitContainer.SuspendLayout();
-      this.tableLayoutPanel.SuspendLayout();
-      this.localPluginDetailsGroupBox.SuspendLayout();
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.uploadButton = new System.Windows.Forms.Button();
       this.SuspendLayout();
       // 
       // listView
       // 
+      this.listView.Activation = System.Windows.Forms.ItemActivation.TwoClick;
       this.listView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
+      this.listView.CheckBoxes = true;
       this.listView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
             this.nameHeader,
@@ -54,13 +49,16 @@
             this.serverVersion});
       this.listView.Enabled = false;
-      this.listView.Location = new System.Drawing.Point(3, 32);
-      this.listView.MultiSelect = false;
+      this.listView.FullRowSelect = true;
+      this.listView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
+      this.listView.Location = new System.Drawing.Point(0, 30);
       this.listView.Name = "listView";
       this.listView.ShowGroups = false;
-      this.listView.Size = new System.Drawing.Size(392, 459);
+      this.listView.Size = new System.Drawing.Size(536, 446);
+      this.listView.StateImageList = this.imageList;
       this.listView.TabIndex = 0;
       this.listView.UseCompatibleStateImageBehavior = false;
       this.listView.View = System.Windows.Forms.View.Details;
-      this.listView.SelectedIndexChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
+      this.listView.ItemActivate += new System.EventHandler(this.listView_ItemActivate);
+      this.listView.ItemChecked += new System.Windows.Forms.ItemCheckedEventHandler(this.listView_ItemChecked);
       // 
       // nameHeader
@@ -74,55 +72,34 @@
       this.localVersion.Width = 100;
       // 
-      // uploadButton
+      // serverVersion
       // 
-      this.uploadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.uploadButton.Enabled = false;
-      this.uploadButton.Location = new System.Drawing.Point(6, 459);
-      this.uploadButton.Name = "uploadButton";
-      this.uploadButton.Size = new System.Drawing.Size(110, 23);
-      this.uploadButton.TabIndex = 2;
-      this.uploadButton.Text = "Upload plugin";
-      this.uploadButton.UseVisualStyleBackColor = true;
-      this.uploadButton.Click += new System.EventHandler(this.uploadButton_Click);
+      this.serverVersion.Text = "Server version";
+      this.serverVersion.Width = 100;
       // 
-      // splitContainer
+      // imageList
       // 
-      this.splitContainer.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.splitContainer.Location = new System.Drawing.Point(0, 0);
-      this.splitContainer.Name = "splitContainer";
+      this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
+      this.imageList.ImageSize = new System.Drawing.Size(16, 16);
+      this.imageList.TransparentColor = System.Drawing.Color.Transparent;
       // 
-      // splitContainer.Panel1
+      // serverUrlLabel
       // 
-      this.splitContainer.Panel1.Controls.Add(this.label1);
-      this.splitContainer.Panel1.Controls.Add(this.serverUrlTextBox);
-      this.splitContainer.Panel1.Controls.Add(this.connectButton);
-      this.splitContainer.Panel1.Controls.Add(this.listView);
-      // 
-      // splitContainer.Panel2
-      // 
-      this.splitContainer.Panel2.Controls.Add(this.tableLayoutPanel);
-      this.splitContainer.Size = new System.Drawing.Size(852, 494);
-      this.splitContainer.SplitterDistance = 398;
-      this.splitContainer.TabIndex = 3;
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 8);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(98, 13);
-      this.label1.TabIndex = 5;
-      this.label1.Text = "Deployment server:";
+      this.serverUrlLabel.AutoSize = true;
+      this.serverUrlLabel.Location = new System.Drawing.Point(3, 6);
+      this.serverUrlLabel.Name = "serverUrlLabel";
+      this.serverUrlLabel.Size = new System.Drawing.Size(98, 13);
+      this.serverUrlLabel.TabIndex = 5;
+      this.serverUrlLabel.Text = "Deployment server:";
       // 
       // serverUrlTextBox
       // 
-      this.serverUrlTextBox.Location = new System.Drawing.Point(107, 5);
+      this.serverUrlTextBox.Location = new System.Drawing.Point(107, 3);
       this.serverUrlTextBox.Name = "serverUrlTextBox";
-      this.serverUrlTextBox.Size = new System.Drawing.Size(107, 20);
+      this.serverUrlTextBox.Size = new System.Drawing.Size(246, 20);
       this.serverUrlTextBox.TabIndex = 4;
       // 
       // connectButton
       // 
-      this.connectButton.Location = new System.Drawing.Point(220, 3);
+      this.connectButton.Location = new System.Drawing.Point(359, 1);
       this.connectButton.Name = "connectButton";
       this.connectButton.Size = new System.Drawing.Size(75, 23);
@@ -132,55 +109,24 @@
       this.connectButton.Click += new System.EventHandler(this.connectButton_Click);
       // 
-      // tableLayoutPanel
+      // refreshButton
       // 
-      this.tableLayoutPanel.ColumnCount = 2;
-      this.tableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel.Controls.Add(this.serverPluginDetailsGroupBox, 1, 0);
-      this.tableLayoutPanel.Controls.Add(this.localPluginDetailsGroupBox, 0, 0);
-      this.tableLayoutPanel.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableLayoutPanel.Location = new System.Drawing.Point(0, 0);
-      this.tableLayoutPanel.Name = "tableLayoutPanel";
-      this.tableLayoutPanel.RowCount = 1;
-      this.tableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel.Size = new System.Drawing.Size(450, 494);
-      this.tableLayoutPanel.TabIndex = 3;
+      this.refreshButton.Location = new System.Drawing.Point(440, 1);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(75, 23);
+      this.refreshButton.TabIndex = 6;
+      this.refreshButton.Text = "Refresh";
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
       // 
-      // serverPluginDetailsGroupBox
+      // uploadButton
       // 
-      this.serverPluginDetailsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.serverPluginDetailsGroupBox.Location = new System.Drawing.Point(228, 3);
-      this.serverPluginDetailsGroupBox.Name = "serverPluginDetailsGroupBox";
-      this.serverPluginDetailsGroupBox.Size = new System.Drawing.Size(219, 488);
-      this.serverPluginDetailsGroupBox.TabIndex = 3;
-      this.serverPluginDetailsGroupBox.TabStop = false;
-      this.serverPluginDetailsGroupBox.Text = "Server plugin information";
-      // 
-      // localPluginDetailsGroupBox
-      // 
-      this.localPluginDetailsGroupBox.Controls.Add(this.localPluginDetailsPanel);
-      this.localPluginDetailsGroupBox.Controls.Add(this.uploadButton);
-      this.localPluginDetailsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.localPluginDetailsGroupBox.Location = new System.Drawing.Point(3, 3);
-      this.localPluginDetailsGroupBox.Name = "localPluginDetailsGroupBox";
-      this.localPluginDetailsGroupBox.Size = new System.Drawing.Size(219, 488);
-      this.localPluginDetailsGroupBox.TabIndex = 4;
-      this.localPluginDetailsGroupBox.TabStop = false;
-      this.localPluginDetailsGroupBox.Text = "Local plugin information";
-      // 
-      // localPluginDetailsPanel
-      // 
-      this.localPluginDetailsPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.localPluginDetailsPanel.Location = new System.Drawing.Point(6, 19);
-      this.localPluginDetailsPanel.Name = "localPluginDetailsPanel";
-      this.localPluginDetailsPanel.Size = new System.Drawing.Size(207, 434);
-      this.localPluginDetailsPanel.TabIndex = 3;
-      // 
-      // serverVersion
-      // 
-      this.serverVersion.Text = "Server version";
-      this.serverVersion.Width = 100;
+      this.uploadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.uploadButton.Location = new System.Drawing.Point(3, 482);
+      this.uploadButton.Name = "uploadButton";
+      this.uploadButton.Size = new System.Drawing.Size(75, 23);
+      this.uploadButton.TabIndex = 7;
+      this.uploadButton.Text = "Upload";
+      this.uploadButton.UseVisualStyleBackColor = true;
+      this.uploadButton.Click += new System.EventHandler(this.uploadButton_Click);
       // 
       // PluginListView
@@ -188,14 +134,14 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.splitContainer);
+      this.Controls.Add(this.uploadButton);
+      this.Controls.Add(this.refreshButton);
+      this.Controls.Add(this.connectButton);
+      this.Controls.Add(this.serverUrlTextBox);
+      this.Controls.Add(this.serverUrlLabel);
+      this.Controls.Add(this.listView);
       this.Name = "PluginListView";
-      this.Size = new System.Drawing.Size(852, 494);
-      this.splitContainer.Panel1.ResumeLayout(false);
-      this.splitContainer.Panel1.PerformLayout();
-      this.splitContainer.Panel2.ResumeLayout(false);
-      this.splitContainer.ResumeLayout(false);
-      this.tableLayoutPanel.ResumeLayout(false);
-      this.localPluginDetailsGroupBox.ResumeLayout(false);
+      this.Size = new System.Drawing.Size(539, 508);
       this.ResumeLayout(false);
+      this.PerformLayout();
 
     }
@@ -206,14 +152,11 @@
     private System.Windows.Forms.ColumnHeader nameHeader;
     private System.Windows.Forms.ColumnHeader localVersion;
+    private System.Windows.Forms.Button connectButton;
+    private System.Windows.Forms.Label serverUrlLabel;
+    private System.Windows.Forms.TextBox serverUrlTextBox;
+    private System.Windows.Forms.ColumnHeader serverVersion;
+    private System.Windows.Forms.Button refreshButton;
     private System.Windows.Forms.Button uploadButton;
-    private System.Windows.Forms.SplitContainer splitContainer;
-    private System.Windows.Forms.Button connectButton;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.TextBox serverUrlTextBox;
-    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel;
-    private System.Windows.Forms.GroupBox serverPluginDetailsGroupBox;
-    private System.Windows.Forms.GroupBox localPluginDetailsGroupBox;
-    private System.Windows.Forms.Panel localPluginDetailsPanel;
-    private System.Windows.Forms.ColumnHeader serverVersion;
+    private System.Windows.Forms.ImageList imageList;
   }
 }
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.cs	(revision 2859)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.cs	(revision 2860)
@@ -23,4 +23,6 @@
     public PluginListView() {
       InitializeComponent();
+      imageList.Images.Add(HeuristicLab.Common.Resources.VS2008ImageLibrary.Assembly);
+      imageList.Images.Add(HeuristicLab.Common.Resources.VS2008ImageLibrary.ArrowUp);
       Caption = "Plugins";
 
@@ -31,4 +33,5 @@
       localAndServerPlugins = new Dictionary<IPluginDescription, PluginDeploymentService.PluginDescription>();
 
+      #region initialize backgroundworkers
       pluginUploadWorker = new BackgroundWorker();
       pluginUploadWorker.DoWork += new DoWorkEventHandler(pluginUploadWorker_DoWork);
@@ -38,9 +41,16 @@
       updateServerPluginsWorker.DoWork += new DoWorkEventHandler(updateServerPluginsWorker_DoWork);
       updateServerPluginsWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(updateServerPluginsWorker_RunWorkerCompleted);
-    }
-
+      #endregion
+    }
+
+    #region refresh plugins from server backgroundworker
     void updateServerPluginsWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
       if (!e.Cancelled && e.Result != null) {
-        UpdateLocalPlugins();
+        // refresh local plugins
+        localAndServerPlugins.Clear();
+        foreach (var plugin in ApplicationManager.Manager.Plugins) {
+          localAndServerPlugins.Add(plugin, null);
+        }
+        // refresh server plugins (find matching local plugins)
         var plugins = (PluginDeploymentService.PluginDescription[])e.Result;
         foreach (var plugin in plugins) {
@@ -53,18 +63,16 @@
           }
         }
-        UpdatePluginList();
-        OnConnected();
-      } else {
-        OnDisconnected();
-      }
+        // refresh the list view with plugins
+        listView.Items.Clear();
+        foreach (var pair in localAndServerPlugins) {
+          var item = MakeListViewItem(pair.Key);
+          listView.Items.Add(item);
+        }
+        UpdateControlsConnectedState();
+      } else {
+        UpdateControlsDisconnectedState();
+      }
+      // make sure cursor is set correctly
       Cursor = Cursors.Default;
-    }
-
-    private void UpdatePluginList() {
-      listView.Items.Clear();
-      foreach (var pair in localAndServerPlugins) {
-        var item = MakeListViewItem(pair.Key);
-        listView.Items.Add(item);
-      }
     }
 
@@ -76,28 +84,112 @@
         }
       }
-      catch (EndpointNotFoundException ex) {
+      catch (EndpointNotFoundException) {
         e.Result = null;
         e.Cancel = true;
       }
-      catch (FaultException ex) {
+      catch (FaultException) {
         e.Result = null;
         e.Cancel = true;
       }
     }
-
+    #endregion
+
+    #region upload plugins to server backgroundworker
     void pluginUploadWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
-      this.Enabled = true;
+      Cursor = Cursors.Default;
+      if (e.Cancelled) {
+        UpdateControlsDisconnectedState();
+      } else {
+        UpdateControlsConnectedState();
+        // start another async call to refresh plugin information from server
+        RefreshPluginsAsync();
+      }
     }
 
     void pluginUploadWorker_DoWork(object sender, DoWorkEventArgs e) {
-      var selectedPlugins = (IEnumerable<IPluginDescription>)e.Argument;
-      using (PluginDeploymentService.AdminClient adminClient = new PluginDeploymentService.AdminClient()) {
-
-        foreach (var plugin in IteratePlugins(selectedPlugins)) {
-          adminClient.DeployPlugin(MakePluginDescription(plugin), CreateZipPackage(plugin));
-        }
-      }
-    }
-
+      try {
+        var selectedPlugins = (IEnumerable<IPluginDescription>)e.Argument;
+        using (PluginDeploymentService.AdminClient adminClient = new PluginDeploymentService.AdminClient()) {
+
+          foreach (var plugin in IteratePlugins(selectedPlugins)) {
+            adminClient.DeployPlugin(MakePluginDescription(plugin), CreateZipPackage(plugin));
+          }
+        }
+        e.Cancel = false;
+      }
+      catch (EndpointNotFoundException) {
+        e.Cancel = true;
+      }
+      catch (FaultException) {
+        e.Cancel = true;
+      }
+    }
+    #endregion
+
+
+    #region button events
+    private void uploadButton_Click(object sender, EventArgs e) {
+      var selectedPlugins = from item in listView.Items.Cast<ListViewItem>()
+                            where item.Checked
+                            where item.Tag is IPluginDescription
+                            select item.Tag as IPluginDescription;
+      if (selectedPlugins.Count() > 0) {
+        Cursor = Cursors.AppStarting;
+        DisableControl();
+        pluginUploadWorker.RunWorkerAsync(selectedPlugins.ToList());
+      }
+    }
+
+    private void connectButton_Click(object sender, EventArgs e) {
+      if (connectButton.Text == "Connect") {
+        DisableControl();
+        RefreshPluginsAsync();
+      } else {
+        UpdateControlsDisconnectedState();
+      }
+    }
+
+    private void refreshButton_Click(object sender, EventArgs e) {
+      DisableControl();
+      RefreshPluginsAsync();
+    }
+
+    #endregion
+
+    #region item list events
+    private void listView_ItemActivate(object sender, EventArgs e) {
+      foreach (var item in listView.SelectedItems) {
+        var plugin = (IPluginDescription)((ListViewItem)item).Tag;
+        var compView = new PluginComparisonView(plugin, localAndServerPlugins[plugin]);
+        compView.Show();
+      }
+    }
+
+    private void listView_ItemChecked(object sender, ItemCheckedEventArgs e) {
+      // also check all dependencies
+      if (e.Item.Checked) {
+        uploadButton.Enabled = true;
+        var plugin = (IPluginDescription)e.Item.Tag;
+        foreach (var dep in plugin.Dependencies) {
+          var depItem = FindItemForPlugin(dep);
+          if (!depItem.Checked) depItem.Checked = true;
+        }
+      } else {
+        uploadButton.Enabled = (from i in listView.Items.Cast<ListViewItem>()
+                                where i.Checked
+                                select i).Any();
+        // also uncheck all dependent plugins
+        var plugin = (IPluginDescription)e.Item.Tag;
+        foreach (ListViewItem item in listView.Items) {
+          var dep = (IPluginDescription)item.Tag;
+          if (dep.Dependencies.Contains(plugin) && item.Checked) {
+            item.Checked = false;
+          }
+        }
+      }
+    }
+    #endregion
+
+    #region helper methods
     private byte[] CreateZipPackage(IPluginDescription plugin) {
       using (MemoryStream stream = new MemoryStream()) {
@@ -113,4 +205,22 @@
     }
 
+    private ListViewItem MakeListViewItem(IPluginDescription plugin) {
+      ListViewItem item;
+      if (localAndServerPlugins[plugin] != null) {
+        item = new ListViewItem(new string[] { plugin.Name, plugin.Version.ToString(), localAndServerPlugins[plugin].Version.ToString() });
+      } else {
+        item = new ListViewItem(new string[] { plugin.Name, plugin.Version.ToString(), string.Empty });
+      }
+      item.Tag = plugin;
+      item.Checked = false;
+      return item;
+    }
+
+    private ListViewItem FindItemForPlugin(IPluginDescription dep) {
+      return (from i in listView.Items.Cast<ListViewItem>()
+              where i.Tag == dep
+              select i).Single();
+    }
+
     private PluginDeploymentService.PluginDescription MakePluginDescription(IPluginDescription plugin) {
       var dependencies = from dep in plugin.Dependencies
@@ -118,5 +228,5 @@
       if (string.IsNullOrEmpty(plugin.ContactName) || string.IsNullOrEmpty(plugin.ContactEmail)) {
         return new PluginDeploymentService.PluginDescription(plugin.Name, plugin.Version, dependencies);
-      } else return new PluginDeploymentService.PluginDescription(plugin.Name, plugin.Version, dependencies, plugin.ContactName + ", " + plugin.ContactEmail, plugin.LicenseText);
+      } else return new PluginDeploymentService.PluginDescription(plugin.Name, plugin.Version, dependencies, plugin.ContactName, plugin.ContactEmail, plugin.LicenseText);
     }
 
@@ -130,80 +240,45 @@
     }
 
-    public void UpdateLocalPlugins() {
-      localAndServerPlugins.Clear();
-
-      foreach (var plugin in ApplicationManager.Manager.Plugins) {
-        localAndServerPlugins.Add(plugin, null);
-      }
-    }
-
-
-    private ListViewItem MakeListViewItem(IPluginDescription plugin) {
-      ListViewItem item;
-      if (localAndServerPlugins[plugin] != null) {
-        item = new ListViewItem(new string[] { plugin.Name, plugin.Version.ToString(), localAndServerPlugins[plugin].Version.ToString() });
-      } else {
-        item = new ListViewItem(new string[] { plugin.Name, plugin.Version.ToString(), string.Empty });
-      }
-      item.Tag = plugin;
-      return item;
-    }
-
-    private void listView_SelectedIndexChanged(object sender, EventArgs e) {
-      localPluginDetailsPanel.Controls.Clear();
-      serverPluginDetailsGroupBox.Controls.Clear();
-
-      if (listView.SelectedItems.Count > 0) {
-        var plugin = (IPluginDescription)listView.SelectedItems[0].Tag;
-        ShowPluginDetails(plugin);
-      }
-    }
-
-    private void ShowPluginDetails(IPluginDescription plugin) {
-      var localView = new LocalPluginView(plugin);
-      var serverView = new ServerPluginView(localAndServerPlugins[plugin]);
-      localView.Dock = DockStyle.Fill;
-      serverView.Dock = DockStyle.Fill;
-      localPluginDetailsPanel.Controls.Add(localView);
-      serverPluginDetailsGroupBox.Controls.Add(serverView);
-    }
-
-    private void uploadButton_Click(object sender, EventArgs e) {
-      if (listView.SelectedItems.Count > 0) {
-        var selectedPlugins = from item in listView.SelectedItems.Cast<ListViewItem>()
-                              where item.Tag is IPluginDescription
-                              select item.Tag as IPluginDescription;
-        this.Enabled = false;
-        pluginUploadWorker.RunWorkerAsync(selectedPlugins.ToList());
-      }
-    }
-
-    private void connectButton_Click(object sender, EventArgs e) {
-      OnDisconnected();
+    // start background process to refresh the plugin list (local and server)
+    private void RefreshPluginsAsync() {
       Cursor = Cursors.AppStarting;
+      DisableControl();
       updateServerPluginsWorker.RunWorkerAsync();
     }
 
-    private void OnConnected() {
-      connectButton.Enabled = false;
-      serverUrlTextBox.Enabled = false;
-      label1.Enabled = false;
-
-      listView.Enabled = true;
-      uploadButton.Enabled = true;
-    }
-
-    private void OnDisconnected() {
-      connectButton.Enabled = true;
+    // is called by all methods that start a background process
+    // controls must be enabled manuall again when the backgroundworker finishes
+    private void DisableControl() {
+      MainFormManager.GetMainForm<MainForm>().ShowProgressBar();
+      foreach (Control ctrl in Controls)
+        ctrl.Enabled = false;
+    }
+
+    private void UpdateControlsDisconnectedState() {
+      connectButton.Text = "Connect";
       serverUrlTextBox.Enabled = true;
-      label1.Enabled = true;
+      serverUrlLabel.Enabled = true;
+      refreshButton.Enabled = false;
 
       localAndServerPlugins.Clear();
       listView.Items.Clear();
-      localPluginDetailsPanel.Controls.Clear();
-      serverPluginDetailsGroupBox.Controls.Clear();
       listView.Enabled = false;
       uploadButton.Enabled = false;
-    }
+      MainFormManager.GetMainForm<MainForm>().HideProgressBar();
+    }
+
+    private void UpdateControlsConnectedState() {
+      connectButton.Text = "Disconnect";
+      connectButton.Enabled = true;
+      serverUrlTextBox.Enabled = false;
+      serverUrlLabel.Enabled = false;
+      refreshButton.Enabled = true;
+      listView.Enabled = true;
+      uploadButton.Enabled = false;
+      MainFormManager.GetMainForm<MainForm>().HideProgressBar();
+    }
+
+
+    #endregion
   }
 }
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.resx
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.resx	(revision 2859)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.DeploymentService.AdminClient/PluginListView.resx	(revision 2860)
@@ -118,3 +118,6 @@
     <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
+  <metadata name="imageList.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
 </root>
